
%% obtain toy data from model (2) (with p = 100, N = 20).
imodel = 2;
trparam.N1 = 10;
trparam.N2 = 10;
trparam.p = 100;
% generating training data
[data, y, datacol, sIND, yIND] = simdata_models(imodel, trparam);
% generating testing data with N = 100.
testparam = trparam; 
testparam.N1 = 50; 
testparam.N2 = 50;
[newX, ynew, datacolN, sINDN, yINDN] = simdata_models(imodel, testparam);

%save sampledata;
%load sampledata;

%% perform the proposed set classification 
params.iclassifier = 'LDA';
[rule1 PCsMap]= SetFeatClass(datacol,sIND,y,params); % training step
[predPCF_LDA, ePCF_LDA]= SetFeatPredict(datacolN,sINDN,rule1,PCsMap,ynew); % testing step

params.iclassifier = 'QDA';
[rule2, PCsMap] = SetFeatClass(datacol,sIND,y,params);
[predPCF_QDA, ePCF_QDA]= SetFeatPredict(datacolN,sINDN,rule2,PCsMap,ynew);
 
%% Run LDA, QDA - MV, WV
paramsLDA.TestData = datacolN;
paramsLDA.Testsetindex = sINDN;
paramsLDA.TestLabel = ynew; 
paramsLDA.classifier = 'LDA';
paramsLDA.strategy = 'MV';
[~, ~, eLDAMV] = setclassmulti(datacol, sIND, y, paramsLDA);

paramsLDA.classifier = 'LDA';
paramsLDA.strategy = 'WV';
[~, ~, eLDAWV] = setclassmulti(datacol, sIND, y, paramsLDA);

paramsLDA.classifier = 'QDA';
paramsLDA.strategy = 'MV';
[~, ~, eQDAMV] = setclassmulti(datacol, sIND, y, paramsLDA);

paramsLDA.classifier = 'QDA';
paramsLDA.strategy = 'WV';
[delta, pred, eQDAWV] = setclassmulti(datacol, sIND, y, paramsLDA);
 
%% Run k-NN Hausdorff 
[~, eNH3]= NNHausdorff(datacol,sIND,y,3,datacolN,sINDN,ynew);  

%% Errorrates;
errorrates = [ePCF_LDA ePCF_QDA eLDAMV eLDAWV eQDAMV eQDAWV eNH3]
bar(errorrates*100);
title('Empirical error rates | training sample')
ylabel(' rates in percent');
set(gca,'XTickLabel',{'PCF_LDA' 'PCF_QDA' 'LDAMV' 'LDAWV' 'QDAMV' 'QDAWV' 'NH3'})



